// components/select/select.js
Component({
    /**
     * 组件的属性列表
     */
    properties: {
        // 左侧提示值
        label: {
            type: String,
            value: ""
        },
        // 文字宽度
        labelWidth: {
            type: String,
            value: ""
        },
        placeholder: {
            type: String,
            value: ""
        },
        // 值
        value: {
            optionalTypes: [String, Array, Number],
            value: []
        },
        // 数据格式
        option: {
            type: [Array],
            value: []
        },
        // 数据格式
        dataType: {
            type: [Object],
            value: {
                value: 'value',
                label: "label"
            }
        }

    },

    /**
     * 组件的初始数据
     */
    data: {
        // 显示列表
        showList: false,
        compValue: []
    },
    lifetimes: {
        attached() {
            this.setData({
                compValue: this.data.value
            })

        }
    },
    // 监听
    observers: {},
    /**
     * 组件的方法列表
     */
    methods: {
        setShowList() {
            this.setData({
                showList: !this.data.showList
            })
        },
        // 点击选项
        onClickItem(e) {
            let {
                value,
                label
            } = e.target.dataset
            if (this.data.compValue.indexOf(value) > -1) {
                // let num = this.data.compValue.indexOf(value)
                let arr = this.data.compValue.filter(item => item != value)
                this.setData({
                    compValue: arr
                })
            } else {
                console.log(this.data.compValue)
                this.data.compValue.push(value)
                let arr = this.data.compValue
                arr.push(value)
                arr = Array.from(new Set(arr))
                this.setData({
                    compValue: arr
                })
            }
            this.triggerEvent("change", this.data.compValue)
        },
        // 删除指定元素
        deleteValue(e) {
            let {
                value
            } = e.target.dataset
            let arr = this.data.compValue.filter((item) => {
                return item != value
            })
            this.setData({
                compValue: arr
            })
            this.triggerEvent("change", this.data.compValue)
        }
    }
})