// custom-tab-bar/index.js
import {
    storeBindingsBehavior
} from "mobx-miniprogram-bindings"
import {
    store
} from "../store/index"
Component({
    behaviors: [storeBindingsBehavior],
    storeBindings: {
        store,
        fields: ["active", "userInfo"],
        actions: {
            upDateActive: "upDateActive",
            setUserInfo: "setUserInfo"
        },
        
    },
    /**
     * 组件的属性列表
     */
    properties: {

    },
    observers:{
        userInfo(){
            if (this.data?.userInfo?.reserve=="teacher") {
                this.setData({
                    type:false
                })
            }else {
                this.setData({
                    type:true
                })
            }
        }
    },
    /**
     * 组件的初始数据
     */
    data: {
        active: 0,
        type:true
    },
    /**
     * 组件的方法列表
     */
    methods: {
        onChange(event) {
            if (!wx.getStorageSync('userInfo')) {
                wx.showToast({
                    title: '请点击授权登录',
                    icon: "none"
                })
                return
            }
            this.upDateActive(event.detail)
            switch (event.detail) {
                case 0:
                    wx.switchTab({
                        url: '/pages/newIndex/newIndex',
                    })
                    break;
                case 1:
                    wx.switchTab({
                        url: '/pages/my/my',
                    })
                default:
                    break;
            }
        },
        onChangeTeacher(event) {
            this.upDateActive(event.detail)
            switch (event.detail) {
                case 0:
                    wx.switchTab({
                        url: '/pages/classes/classes',
                    })
                    break;
                case 1:
                    wx.switchTab({
                        url: '/pages/curriculum/curriculum',
                    })
                    break;
                case 2:
                    wx.switchTab({
                        url: '/pages/my/my',
                    })
                default:
                    break;
            }
        }
    }
})