// student/notSubmit/notSubmit.js
import {
    request,
    throttle
} from "../../../utils/api.js"
const app = getApp()
Page({

    /**
     * 页面的初始数据
     */
    data: {
        active: 0,
        activeNames: ["1"],
        pageNo: 1,
        pageSize: 10,
        total: 0,
        workList: [],
        // 作业列表
        noWorkList: [],
        pageNo1: 1,
        pageSize1: 10,
        total1: 0,
        // 已提交作业列表
        signWorkList: [],
        // 侧边栏激活项
        activeKey: 0,
        activeKeyName: '语文',
        // 页面高度
        vh: 0,
        // 侧边栏列表
        subjectList: [{
                label: "语文",
                value: 0
            },
            {
                label: "数学",
                value: 1
            },
            {
                label: "英语",
                value: 2
            },
            {
                label: "物理",
                value: 3
            },
            {
                label: "化学",
                value: 4
            },
            {
                label: "生物",
                value: 5
            },
            {
                label: "历史",
                value: 6
            },
            {
                label: "地理",
                value: 7
            },
            {
                label: "政治",
                value: 8
            },
        ],
    },
    // 侧边栏变化事件
    onChangeSidebar(e) {
        let name = this.data.subjectList.filter(val => val.value == e.detail)
        this.setData({
            activeKey: e.detail,
            activeKeyName: name[0].label,
        })
        if (this.data.active === 0) {
            this.setData({
                pageNo: 1,
                noWorkList: []
            })
            this.getNoWorkList()
        } else {
            this.setData({
                pageNo1: 1,
                workList: []
            })
            this.getWorkList()
        }
    },
    /**
     * 生命周期函数--监听页面加载
     */
    onLoad(options) {
        // console.log(app)
        let {
            windowHeight,
            statusBarHeight
        } = wx.getSystemInfoSync()
        // console.log(data)
        this.setData({
            vh: windowHeight - statusBarHeight
        })
    },


    onChangeCollapse(e) {
        this.setData({
            activeNames: e.detail,
        });
    },
    saveCanvasImage(e) {
        this.data.myCanvas.saveCanvasImage(this.data.homeworkId, this.data.studentId, "teacher");
    },
    onChange(e) {
        this.setData({
            active: e.detail.index
        })
    },
    // 未提交上拉触底时间
    scrolltolower() {
        // console.log("eee")
        if (this.data.pageNo * this.data.pageSize < this.data.total) {
            this.setData({
                pageNo: this.data.pageNo += 1,
            })
            // 未提交
            this.getNoWorkList()
        }
    },
    // 已提交上拉触底
    scrolltolowerOn() {
        if (this.data.pageNo1 * this.data.pageSize1 < this.data.total1) {
            this.setData({
                pageNo: this.data.pageNo1 += 1,
            })
            this.getWorkList()
        }
    },
    onReachBottom() {

    },
    onPullDownRefresh() {
        if (this.data.active === 0) {
            this.setData({
                pageNo: 1,
                noWorkList: []
            })
            // 获取未提交
            this.getNoWorkList()
        } else {
            this.setData({
                pageNo1: 1,
                workList: []
            })
            this.getWorkList()
        }
    },
    // 获取未提交
    getNoWorkList: throttle(async function () {

        let {
            pageNo,
            pageSize,
            total,
            activeKeyName
        } = this.data
        let userInfo = wx.getStorageSync('userInfo')
        if (userInfo?.classId == null || userInfo?.classId == void 0 || userInfo?.classId == "") {
            wx.showToast({
                title: '未分配班级',
                icon: "error"
            })
            return;
        }
        const {
            data
        } = await request("/app-api/tutor/h5/getClassHomework", "GET", {
            pageNo: pageNo,
            pageSize: pageSize,
            studentId: userInfo.id,
            classId: userInfo.classId,
            subject: activeKeyName
        })
        this.setData({
            noWorkList: [...this.data.noWorkList, ...data.list],
            total: data.total1
        })
    }),
    // 获取已提交
    getWorkList: throttle(async function () {
        let {
            pageNo1,
            pageSize1,
            total1,
            activeKeyName
        } = this.data
        let userInfo = wx.getStorageSync('userInfo')
        if (userInfo?.classId == null || userInfo?.classId == void 0 || userInfo?.classId == "") {
            wx.showToast({
                title: '未分配班级',
                icon: "error"
            })
            return;
        }
        const {
            data
        } = await request("/app-api/tutor/h5/getStudentHomework", "GET", {
            pageNo1,
            pageSize1,
            studentId: userInfo.id,
            classId: userInfo.classId,
            subject: activeKeyName

        })

        this.setData({
            workList: [...this.data.workList, ...data.list],
            total1: data.total
        })

    }),
    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady() {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow() {
        this.setData({
            pageNo: 1,
            pageNo1: 1,
            workList: [],
            noWorkList: []
        })
        this.getNoWorkList()
        this.getWorkList()
    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide() {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload() {

    },


    /**
     * 用户点击右上角分享
     */
    onShareAppMessage() {

    }
})