// student/pages/submitWork/submitWork.js
import {
    request,
    throttle
} from "../../../utils/api"
Page({

    /**
     * 页面的初始数据
     */
    data: {
        activeKey: 0,
        activeNames: ["1"],
        workList: [],
        pageNo: 1,
        pageSize: 20,
        total: 0,
        vh: 0,
        subjectList: [{
                label: "语文",
                value: 0
            },
            {
                label: "数学",
                value: 1
            },
            {
                label: "英语",
                value: 2
            },
            {
                label: "物理",
                value: 3
            },
            {
                label: "化学",
                value: 4
            },
            {
                label: "生物",
                value: 5
            },
            {
                label: "历史",
                value: 6
            },
            {
                label: "地理",
                value: 7
            },
            {
                label: "政治",
                value: 8
            },
        ],
    },
    // 跳转到作业列表
    toCorrect() {
        wx.navigateTo({
            url: '/student/pages/correcting/correcting',
        })
    },
    // 侧边栏变化事件
    onChangeSidebar(e) {
        this.setData({
            activeKey: e.detail,
            pageNo: 1,
            workList: []
        })
        this.getWorkList()
    },
    onChangeCollapse(e) {
        this.setData({
            activeNames: e.detail,
        });
    },
    getWorkList: throttle(async function () {
        // 页数 
        let {
            pageNo,
            pageSize,
            activeKey,
            subjectList
        } = this.data
        let sujectKey = subjectList.filter(item => {
            return item.value == activeKey
        })
        let subject = sujectKey[0].label
        console.log(subject)
        let {
            classId,
            id
        } = wx.getStorageSync('userInfo')
        if (!classId) {
            wx.showToast({
                title: '未加入班级',
                icon: "error"
            })
        }
        let {
            data
        } = await request("/app-api/tutor/h5/getStudentsHomeworkPage", "GET", {
            pageNo,
            pageSize,
            studentId: id,
            classId,
            reserve: 1,
            subject,
        })
        this.setData({
            workList: [...this.data.workList, ...data.list],
            total: data.total
        })
    }),
    /**
     * 生命周期函数--监听页面加载
     */
    onLoad(options) {
        let {
            windowHeight,
            statusBarHeight
        } = wx.getSystemInfoSync()
        // console.log(data)
        this.setData({
            vh: windowHeight - statusBarHeight
        })
    },

    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady() {
        this.getWorkList()
    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow() {

    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide() {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload() {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh() {
        this.setData({
            pageNo: 1,
            workList: []
        })
        this.getWorkList()
    },

    /**
     * 页面上拉触底事件的处理函数
     */
    scrolltolower() {
        let {
            pageNo,
            pageSize,
            total
        } = this.data
        if (pageNo * pageSize < total) {
            this.setData({
                pageNo: pageNo += 1,
            })
            this.getWorkList()

        }
    },
    onReachBottom() {
        // let {
        //     pageNo,
        //     pageSize,
        //     total
        // } = this.data
        // if (pageNo * pageSize < total) {
        //     this.setData({
        //         pageNo: pageNo += 1,
        //     })
        //     this.getWorkList()

        // }
    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage() {

    }
})