// student/pages/userDetail/userDetail.js
import {
    createStoreBindings
} from "mobx-miniprogram-bindings"
import {
    store
} from "../../../store/index"
import {
    address
} from "../../util/city"
import Dialog from '@vant/weapp/dialog/dialog';
Page({

    /**
     * 页面的初始数据
     */
    data: {
        wH: 0,
        // 距顶
        topH: 0,
        // 手机号
        phoneNumber: '',
        newPhoneNumber: "",
        initUserInfo: {},
        // 表单数据
        // 姓名
        name: '',
        // 年龄
        age: "",
        // 性别
        gender: "0",
        // 省
        province: "",
        // 城市
        city: "",
        // 区县
        area: "",

        // 学校名称
        originalSchool: "",
        // 所在年级
        grade: "",
        // 兴趣爱好
        remark: "",
        // 错误信息
        nameRule: "",
        ageRule: '',
        genderRule: '',
        cityRule: '',
        originalSchoolRule: '',
        gradeRule: '',
        remarkRule: '',
        // 性别
        columns: ["男", "女"],
        // 选择性别面板
        showGender: false,
        // 初始性别
        initGender: "0",
        address,
        // 变更地址
        initCity: "",
        showCity: false,
        cascaderValue: '',
        // 自定义地址
        fieldNames: {
            text: "name"
        }
    },
    // 选择性别面板
    onShowGender() {
        this.setData({
            showGender: !this.data.showGender
        })
        if (this.data.showGender) {
            this.setData({
                initGender: this.data.gender
            })
        }
    },
    // 性别变化
    onGenderChange(e) {
        this.setData({
            gender: e.detail
        });
    },
    // 性别确认
    onGender() {
        this.setData({
            showGender: false
        })
    },
    // 关闭，恢复初始值
    colseGender() {
        this.setData({
            showGender: false,
            gender: this.data.initGender
        })
    },
    // 关闭选择地址
    onCloseCity() {
        this.setData({
            showCity: false,
        });
    },
    // 打开选择地址
    onClickCity() {
        this.setData({
            showCity: true,
        });
    },
    // 保存地址
    onFinishCity(e) {
        const {
            selectedOptions,
            value
        } = e.detail;
        // console.log(selectedOptions)
        const initCity = selectedOptions
            .map((option) => option.text || option.name)
            .join('/');
        this.setData({
            province: selectedOptions[0].name,
            city: selectedOptions[1].name,
            area: selectedOptions[2].name,
            initCity,
            showCity: false,
        })
        // console.log(initCity)
    },
    nameChange(e) {
        if (this.data.name == "") {
            this.setData({
                nameRule: "学生姓名不能为空"
            })
        }
    },
    // 离开当前页
    goBack() {
        // console.log(111)
        // Dialog.confirm({
        //         title: '保存信息',
        //         message: '请确认本次修改以提交，点击确认返回上级页面',
        //     })
        //     .then(() => {
        // on confirm
        wx.switchTab({
            url: '/pages/my/my',
        })
        // })
        // .catch(() => {
        //     // on cancel
        // });
    },
    submitForm() {
        let {
            nameRule,
            ageRule,
            age
        } = this.data
        let ageRex = /^1\d{10}$/
        if (!ageRex.test(age)) {
            this.setData({
                ageRule: "请输入正确年龄"
            })
        }
        if (!nameRule || !ageRule) {
            console.log("错误")

        }
        // 年龄
    },
    // onGenderClick(event) {
    //     const {
    //         name
    //     } = event.currentTarget.dataset;
    //     this.setData({
    //         gender: name,
    //     });
    // },
    // 初始化学生信息
    initStudentData() {
        let {
            age,
            area,
            city,
            province,
            name,
            phoneNumber,
            originalSchool,
            gender,
            classId
        } = this.data.initUserInfo
        let initCity = ""
        if (province !== '') {
            initCity += province
            initCity += '/'
        }
        if (city !== '') {
            initCity += city
            initCity += '/'
        }
        if (area !== '') {
            initCity += area
        }
        this.setData({
            age,
            area,
            city,
            province,
            name,
            phoneNumber,
            originalSchool,
            gender,
            classId,
            initCity
        })
    },
    /**
     * 生命周期函数--监听页面加载
     */
    onLoad(options) {
        // this.storeBindings = createStoreBindings(this, {
        //     store,
        //     fields: ["userInfo"],
        //     actions: {

        //     }
        // })
        let user = wx.getStorageSync('userInfo')
        this.setData({
            initUserInfo: user
        })
        let {
            windowHeight,
            statusBarHeight
        } = wx.getSystemInfoSync()
        this.setData({
            wH: windowHeight - 46 - statusBarHeight,
            topH: statusBarHeight,
        })
        this.initStudentData()
    },

    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady() {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow() {
        // 处理手机号
        // 转字符
        let numPhone = this.data.phoneNumber.substr(0, 4) + "****" +
            this.data.phoneNumber.substr(7, 12)
        console.log(numPhone)
        this.setData({
            newPhoneNumber: numPhone
        })
    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide() {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload() {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh() {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom() {

    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage() {

    }
})