// student/pages/workDetail.js
import {
    request
} from "../../../utils/api"
Page({
    /**
     * 页面的初始数据
     */
    data: {
        // 页面高度
        wH: 0,
        // 是否显示遮罩
        dialogActive: false,
        homeworkId: '',
        studentId: '',
        subject: '',
        // workPath: "https://purchase.platomix.net/homework/k6j1679996760444.docx",
        loadWorkPath: "",
        // 作业详情
        workDetail:{}
    },
    showDialog() {
        this.setData({
            dialogActive: !this.data.dialogActive
        })
    },
    download() {
        let that = this
        wx.showToast({
            title: '下载中',
            icon: "loading"
        })
        wx.downloadFile({
            url: this.data.workDetail.homeworkPath, //仅为示例，并非真实的资源
            success(res) {
                console.log(res, "res")
                const filePath = res.tempFilePath;
                that.setData({
                    loadWorkPath: filePath
                })
                wx.hideToast()

            }
        })
    },
    // 打开文件
    openWork() {
        wx.openDocument({
            filePath: this.data.loadWorkPath,
            // showMenu: true,
            // fileType:,
            success: function (resp) {
                console.log('打开文档成功', resp)
            }
        })
    },
    // 跳转到编辑页
    toWorkEdit(e) {
        let {
            homeworkId,
            studentId,
            subject
        } = this.data
        wx.navigateTo({
            url: '/pages/index/index?homeworkId=' + homeworkId + "&studentId=" + studentId + '&subject=' + subject
        })
    },
    // 获取单个作业数据
    async getWorkDetail() {
        const res = await request("/app-api/tutor/h5/getHomeworkDetail", 'GET', {
            id: this.data.homeworkId
        })
        this.setData({
            workDetail: res.data
        })
        console.log(res, "detail")
    },
    // 下载文件
    onLoadDetail() {

    },
    /**
     * 生命周期函数--监听页面加载
     */
    onLoad(options) {
        let {
            windowHeight
        } = wx.getSystemInfoSync()
        this.setData({
            wH: windowHeight
        })
        this.setData({
            homeworkId: options.homeworkId,
            studentId: options.studentId,
            subject: options.subject
        })
    },

    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady() {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow() {
        // 获取单个数据
        this.getWorkDetail()
    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide() {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload() {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh() {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom() {

    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage() {

    }
})