// teacher/pages/studentList/studentList.js
import {
    request,
    throttle,
    debounce
} from "../../../utils/api"
Page({

    /**
     * 页面的初始数据
     */
    data: {
        // 班级ID
        classId: 0,
        pageNo: 1,
        pageSize: 10,
        total: 11,
        //学生列表
        studentList: [],
        // 班级名称
        className: '',
        searchValue: ""
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad(options) {
        let {
            classId,
            className
        } = options
        this.setData({
            classId,
            className
        })

    },

    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady() {

    },
    onStudentWork() {
        // 跳转学生作业
        wx.navigateTo({
            url: '/teacher/pages/workList/workList',
        })
    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow() {
        wx.hideHomeButton()
        this.getStudentList()
    },
    getStudentList: throttle(async function (params) {
        let {
            pageNo,
            pageSize,
            classId,
            total,
            searchValue
        } = this.data
        const {
            data
        } = await request("/app-api/tutor/h5/getStudentsPage", "GET", {
            pageNo,
            pageSize,
            classId,
            name: searchValue
        })
        console.log(data.list)
        wx.stopPullDownRefresh()
        if (pageNo === 1) {
            this.setData({
                studentList: data.list
            })
            return;
        }
        if (pageNo * pageSize < total) {
            this.setData({
                pageNo: pageNo += 1,
                total: data.total,
                studentList: [...this.data.studentList, ...data.list]
            })
        }


    }),
    // 点击搜索
    onSearch(e) {
        if (!e.detail.x) {
            this.setData({
                searchValue: e.detail,
                pageNo: 1,
                total: 11,
            })
        }
        this.getStudentList()
    },
    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide() {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload() {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh() {
        this.setData({
            pageNo: 1,
        })
        this.getStudentList()
    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom() {
        this.setData({
            pageNo: this.data.pageNo += 1
        })
        this.getStudentList()
    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage() {

    }
})