// teacher/pages/workDetail/workDetail.js
import {
    request,
    throttle
} from "../../../utils/api"
import Toast from '@vant/weapp/toast/toast';
import Notify from '@vant/weapp/notify/notify';
const app = getApp()

import {
    myCanvas
} from '../../../pages/canvasWrite_smoothing.js'
import {
    env
} from "../../../env"
Page({

    /**
     * 页面的初始数据
     */
    data: {
        optionsSize: {
            width: 175,
            height: 245
        },
        canvasHeight: 0,
        canvasWidth: 0,
        fullPage: 0,
        canvas: null,
        ctx: null,
        pageImg: ["../../../images/page2.png"],
        isIphoneX: false,
        show: false,
        canvasTop: 0,
        canvasLeft: 0,
        startX: 0,
        startY: 0,
        myCanvas: null,
        homeworkId: "",
        studentId: "",
        dpr: 0,
        // 所有作业数据
        workData: {},
        // 班级名称
        className: "",
        // 学员名称
        studentName: ""
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad(options) {
        let {
            windowWidth,
            windowHeight,
        } = wx.getSystemInfoSync()
        let num = windowHeight / windowWidth
        let number = 0
        if (num > 1.4) {
            number = .9
        } else {
            number = .8
        }
        this.setData({
            optionsSize: {
                width: windowWidth * number,
                height: windowWidth * 1.4 * number,
            
            }
        })
        let {
            homeworkId,
            className,
            studentName
        } = options
        this.setData({
            homeworkId,
            className,
            studentName
        })
    },
    initCanvas() {
        const query = wx.createSelectorQuery()
        query.select('#myCanvas')
            .fields({
                node: true,
                size: true
            })
            .exec((res) => {
                const canvas = res[0].node
                const ctx = canvas.getContext('2d')
                const dpr = wx.getSystemInfoSync().pixelRatio
                let {
                    width,
                    height
                } = this.data.optionsSize
                let options = {
                    width: width / dpr,
                    height: height / dpr
                }
                canvas.width = options.width * dpr
                canvas.height = options.height * dpr
                this.setData({
                    canvas,
                    ctx,
                    dpr
                })
                const img = this.data.canvas.createImage()
                img.src = this.data.workData.homeworkPath

                img.onload = () => {
                    this.data.ctx.drawImage(img, 0, 0, options.width, options.height)
                }


                ctx.scale(dpr, dpr)
                console.log(res[0].node)
            })
    },
    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    saveCanvasImage(e) {
        let that = this
        const base64 = this.data.canvas.toDataURL("png");
        let body = {}
        body.baseStr = base64.substring(22)
        wx.request({
            url: env.baseUrl + '/app-api/tutor/h5/teacherUpload',
            method: 'post',
            data: {
                baseStr: base64.substring(22),
                id: this.data.homeworkId
            },
            header: {
                'content-type': 'application/x-www-form-urlencoded' // 默认值
            },
            success(res) {
                console.log(res.data)
                if (res.data.code == 0) {
                    // toast.success({
                    //     message: "保存成功",
                    //     duration: 1500,
                    // })
                    // Toast.success({
                    //     message: '上传成功',
                    //     duration: 200,
                    //     type: "success"
                    // });
                    Notify({
                        type: 'primary',
                        message: '上传成功'
                    });
                    that.getWorkDetail()
                }
            }
        })
    },
    async getWorkDetail() {
        const {
            data
        } = await request("/app-api/tutor/h5/getStudentHomeworkDetail", "GET", {
            id: this.data.homeworkId
        })
        let detail = data
        detail.homeworkPath = 'https://' + detail.homeworkPath.substring(13)
        this.setData({
            workData: detail
        })
        this.initCanvas()
    },
    onReady() {},
    /**
     * 生命周期函数--监听页面显示
     */
    onClickShow() {
        this.setData({
            show: true
        });
    },

    onClickHide() {
        this.setData({
            show: false
        });
        this.initCanvas()
    },
    onShow() {
        wx.hideHomeButton()
        this.getWorkDetail()
    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide() {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload() {

    },
    touchStart(e) {
        let ctx = this.data.ctx
        let dpr = this.data.dpr
        // 元素当前位置
        let top = e.currentTarget.offsetTop
        let left = e.currentTarget.offsetLeft
        // 鼠标落点
        let startLeft = e.changedTouches[0].x
        let startTop = e.changedTouches[0].y
        let x = startLeft - left
        let y = startTop - top
        ctx.lineWidth = '.5'
        ctx.fillStyle = "#e53c2f"
        ctx.strokeStyle = "#e53c2f"
        ctx.save();
        ctx.beginPath();
        ctx.moveTo(startLeft / dpr, startTop / dpr);
        ctx.lineTo(startLeft / dpr, startTop / dpr);
        ctx.stroke();
        ctx.restore();
    },
    touchMove(e) {
        let dpr = this.data.dpr
        let ctx = this.data.ctx
        let top = e.currentTarget.offsetTop
        let left = e.currentTarget.offsetLeft
        let startLeft = e.changedTouches[0].x
        let startTop = e.changedTouches[0].y
        let x = startLeft - left
        let y = startTop - top
        ctx.lineWidth = '.5'
        // ctx.moveTo(10, 10)
        // ctx.lineTo(100, 10)
        ctx.fillStyle = "#e53c2f"
        ctx.strokeStyle = "#e53c2f"
        ctx.save();
        ctx.lineTo(startLeft / dpr, startTop / dpr);
        ctx.stroke()
        ctx.restore();
    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh() {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom() {

    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage() {

    }
})