// teacher/pages/workList/workList.js
import {
    request,
    throttle
} from "../../../utils/api"
Page({

    /**
     * 页面的初始数据
     */
    data: {
        // 导航栏默认激活项 -是否批改
        active: 0,
        pageList: [],
        pageSize: 10,
        pageNo: 1,
        total: 0,
        // 折叠面板激活
        activeNames: ['1'],
        // 学生id
        studentId: '',
        // 学生姓名
        studentName: ""
        // 班级id
    },
    // 面板变化
    onChangeNames(event) {
        this.setData({
            activeNames: event.detail,
        });
    },
    // tab变化
    onChangeTab(e) {
        this.setData({
            active: e.detail.index
        })
        this.setData({
            pageNo: 1
        })
        this.getList()
    },
    // onChange(event) {},
    goDetail() {
        wx.navigateTo({
            url: '/teacher/pages/workDetail/workDetail',
        })
    },
    /**,
     * 生命周期函数--监听页面加载
     */
    getList: throttle(async function () {
        let {
            pageSize,
            pageNo,
            studentId,
            active
        } = this.data
        const data = await request("/app-api/tutor/h5/getStudentsHomeworkPage", "GET", {
            pageSize,
            pageNo,
            studentId: studentId,
            reserve: active
        })
        wx.stopPullDownRefresh()
        if (pageNo == 1) {
            this.setData({
                pageList: data.data.list
            })
            return;
        }
        this.setData({
            pageList: [...this.data.pageList, ...data.data.list]
        })
    }, 200),
    onLoad(options) {
        this.setData({
            studentId: options.studentId,
            className: options.className,
            studentName: options.studentName
        })
        this.getList()
    },
    goEdit(e) {
        // let path = e.target.dataset
        //     .homeworkpath.substring(13)
        // console.log(e)
        wx.navigateTo({
            url: '/teacher/pages/workDetail/workDetail?homeworkId=' + e.target.dataset.id + '&className=' + this.data.className + '&studentName=' + this.data.studentName,
        })
    },
    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady() {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow() {
        wx.hideHomeButton()
    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide() {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload() {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh() {
        this.setData({
            pageNo: 1,
        })
        this.getList()
    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom() {
        // 11
        if (this.data.pageNo * this.data.pageSize < this.data.total) {
            this.setData({
                pageNo: this.data.pageNo += 1
            })
            this.getList()
        }
    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage() {

    }
})