### 小程序开发文档

1.初始化蓝牙模块

```javascript
const event = require("./event");
const utils = require("./utils");
import { TqlSDK } from "allSDK";
//使用之前先创建实例
// 创建实例时根据不同平台传不同的参数
// 数字 0 微信 1 钉钉 2 飞书 3 uniapp
const tqlSDK = new tqlSDK(0);
//初始化蓝牙
tqlSDK.initBlueTooth(success, fail); //参数为回调函数，可不传,后面的参数为 success,fail同上
//获取本地蓝牙状态
tqlSDK.getLocalBlueToothState(); //返回值为{isDiscovering:bool,isAvailable:bool}
//搜索附近的蓝牙设施
tqlSDK.searchBlueTooth(success, fail);
//查找到的设备列表
tqlSDK.showBlutToothList(that); //that为页面内的this,得到的设备列表 this.data.blueToothList
//创建蓝牙连接
tqlSDK.createBlueToothConnection(deviceId, success, fail); //deviceId为蓝牙设备Id
//停止蓝牙查找
tqlSDK.stopBlueToothSearch(success, fail);
// 释放蓝牙内存
tqlSDK.closeBlueTooth(success, fail);
//写入笔名
tqlSDK.setPenName(panName); //参数为笔名
//请求笔名
tqlSDK.getPenName(success, fail);
//  获取MAC地址
tqlSDL.getMACAddress(success, fail);
// 获取蓝牙固件版本
tqlSDK.getPenFirmWare(success, fail);
// 获取剩余电量
tqlSDK.getPenBattery(success, fail);
// 写入rtc时间
tqlSDK.setRTCTime(RTCTime, success, fail); //RTCTime为修改时间的时间戳
// 请求rtc时间
tqlSDK.getRTCTime(success, fail);
// 写入自动关机时间
tqlSDK.setPenAutoOff(offTime, success, fail); //offTime单位为分钟 范围为0~120 0表示不自动关机
// 请求自动关机时间
tqlSDK.getPenAutoOff(success, fail);
// 获取已使用内存
tqlSDK.getPenMemory(success, fail);
// 获取是否点笔开机
tqlSDK.getPenClickMode(success, fail);
// 设置点笔开机
tqlSDK.setPenClickMode(isClick, success, fail); //isCkick为是否点笔开机 为布尔值
//设置是否蜂鸣
tqlSDK.setPenBeep(isOn, success, fail); //isOn为布尔值
//获取是否蜂鸣
tqlSDK.getPenBeep(success, fail);
//  恢复出厂设置
tqlSDK.restoreFactory(success, fail);
//写入压力敏感度
tqlSDK.setPenSensor(level, success, fail); //level是一个数字 范围为0到4
//获取压力敏感度
tqlSDK.getPenSensor(success, fail);
// 获取压力校正值
tqlSDK.getPenSensorRegulate(success, fail);
//获取mcu固件版本
tqlSDK.getMCUVersion(success, fail);
// 获取笔的类型
tqlSDK.getPenModal(success, fail);
// 获取点码类型
tqlSDK.getPenPointType(success, fail);
// led设置开关
tqlSDK.setLedConfig(isOn, success, fail); //isOn为布尔值
// 获取led是够可以设置的结果
tqlSDK.getLedConfig(success, fail);
// 获取离线数据量大小
tqlSDK.getPenOfflineDataSize(success, fail);
//开始获得离线数据
tqlSDK.startGetOfflineData(success, fail);
// 停止获得离线数据
tqlSDK.stopGetOfflineData(success, fail);
// 暂停获得离线数据
tqlSDK.pauseGetOfflineData(success, fail);
// 继续获得离线数据
tqlSDK.continueGetOfflineData(success, fail);
//删除离线数据
tqlSDK.deleteOfflineData(success, fail);
// 确认离线数据已经接受完毕
tqlSDK.confirmOfflineDataDone(success, fail);

//一下为在页面加载中的监听，监听结果为上面方法笔的返回值
event.on("penData", this, (data) => {
  //data格式为{cmd:'',data}
  switch (data.cmd) {
    case "getPenName": //获取笔名
      break;
    case "setPenName": //设置笔名
      break;
    case "getMacAddress": //获取mac地址
      break;
    case "getBlueToothVersion": //获取蓝牙版本
      break;
    case "getPenBattery": //获取笔的电量
      break;
    case "getRTCtime": //获取笔的时间
      break;
    case "setRTCtime": //设置rtc时间
      break;
    case "getPenAutoShutDownTime": //获取笔是否自动关机
      break;
    case "setPenAutoOff": //设置笔是否自动关机
      break;
    case "RestoreFactorySettings": //恢复出厂设置
      break;
    case "getUsedMomery": //获取笔的内存使用情况
      break;
    case "getPenClickMode": //获取是否点笔开机
      break;
    case "setPenClickMode": //设置是否点笔开机
      break;
    case "getPenBeep": //获取蜂鸣器是否开启
      break;
    case "setPenBeep": //设置蜂鸣器是否开启
      break;
    case "getPenSensor": //获取笔的压力值
      break;
    case "setPenSensor": //设置笔的压力值
      break;
    case "getLEDColor": //获取led灯颜色
      break;
    case "getSensitivityCorrection": //获取笔的压力校正值
      break;
    case "getMCUVersion": //获取mcu固件版本
      break;
    case "getOID4CodeValue": //获取点读码
      break;
    case "penColor": //获取笔的颜色
      break;
    case "getCodePointType": //获取点读码类型
      break;
    case "getOfflineDataNum": //获取离线数据量
      break;
    case "offLineProgress": //离线数据获取进程
      break;
    case "offLineProgressStop": //停止获取离线数据
      break;
    case "offLineProgressPause": //暂停获取离线数据
      break;
    case "offLineProgressContinue": //继续获取离线数据
      break;
    case "offLineProgressFinish": //停止获取离线数据
      break;
    case "offLineDataConfirm": //确认离线数据完成
      break;
    case "offLineDataDelete": //删除离线数据
      break;
    case "offLineProgress": //离线数据获取进程
      break;
  }
});
//监听离线数据获取结束
event.on('finish',this,(data)=>{

})
//监听处理后的数据
event.on("AddressDataChanged", this, (data) => {});
//data为单个被处理过的数据 ，推荐使用数组先将数据存起来
```
