import {
    env
} from "../env"
export const request = (url = "", method = "GET", data = "") => {
    wx.showToast({
        title: '请求中...',
        icon: "loading"
    })
    // let token = wx.getStorageSync('token')
    // 如果无token 跳转登录页
    // if (token) {
    //     // wx.navigateTo({
    //     //   url: 'pages/login/login',
    //     // })
    // }
    return new Promise((resolve, reject) => {
        wx.request({
            url: env.baseUrl + url,
            method,
            data,
            header: {
                'Content-Type': 'application/json;charset=utf-8'
            },
            success: (res) => {
                // 系统错误  请求错误 重新登录
                // 根据状态码 如果有错
                if (res.statusCode !== 200) {
                    wx.showToast({
                        title: '请求出错',
                    })
                    resolve(res.data)
                } else {
                    // 如果没错
                    wx.hideToast()
                    resolve(res.data)
                }
            },
            fail: (err) => {
                wx.showToast({
                    title: '系统错误',
                    icon: "error"
                })
                reject(err)
            }
        })
    })
}
// 防抖函数
export function debounce(fn, interval) {
    var timer;
    var gapTime = interval || 1000; //间隔时间，如果interval不传，则默认1000ms
    return function () {
        clearTimeout(timer);
        var context = this;
        var args = arguments; //保存此处的arguments，因为setTimeout是全局的，arguments不是防抖函数需要的。
        timer = setTimeout(function () {
            fn.call(context, args);
        }, gapTime);
    };
}
/*函数节流*/
export function throttle(fn, interval) {
    var enterTime = 0; //触发的时间
    var gapTime = interval || 300; //间隔时间，如果interval不传，则默认300ms
    return function () {
        var context = this;
        var backTime = new Date(); //第一次函数return即触发的时间
        if (backTime - enterTime > gapTime) {
            fn.call(context, arguments);
            enterTime = backTime; //赋值给第一次触发的时间，这样就保存了第二次触发的时间
        }
    };
}